#define TI82				; select target platform here
;#define TI83

#ifdef TI82
#include CRASH82.INC
#else
#nolist
#include ion.inc
#list
	.ORG	progstart
	xor a
	jr	nc,begin
	ret
#endif

.DB "HUBY TI 0.1", 0
#define db .byte
#define dw .word

;Huby beeper music engine by Shiru (shiru@mail.ru) 04'11
;Two channels of tone, no volume, global speed
;One drum, replaces note on the first channel
;The main feature of this engine is the size, just 100 bytes
;Feel free to do whatever you want with the code, it is PD
;modified for TI82 by utz, Akareyon, and calc84maniac
;well, unfortunately it's more than 100 bytes now :(

	call begin
ex	ei
	ret				
	
begin	ld hl,musicData
	call play
	ret
	
play
	ld e,(hl)			;read speed word
	inc hl
	ld d,(hl)
	inc hl
	ld (speed),de			;store it
	ld e,(hl)			;read patterns offset
	inc hl
	ld d,(hl)			;it will be always in DE, and HL is order list pointer now

readPos
	inc hl
	ld a,(hl)			;read first byte of order list
	or a
	ret z				;if it is zero, it is end of the song
	inc hl
	push hl				;store order list pointer
	push de				;store patterns offset
	ld l,(hl)			;read second byte of order list
	ld bc,2*256			;calculate addresses of two patterns
read
	ld h,c				;pattern number*8
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,de			;add patterns offset
	push hl				;store pattern address
	ld l,a				;now second address
	djnz read
	exx
	pop hl				;restore pattern addressed in alternative set
	pop de

	ld b,8				;play 8 rows
readRow
	ld a,(hl)			;read first note
	inc hl				;increase first pattern pointer
	ex af,af'
	ld a,(de)			;read second note
	inc de				;increase second pattern pointer
	exx
	ld h,a
	ex af,af'
	ld l,a
	cp $2c				;if first note is $2c, it is drum sound
	jr z,$+3
	xor a
	ld (slide),a
speed .EQU $+1
	ld bc,0
	di

soundLoop
	xor a				;clear carry and set A to zero
	dec e				;counter of first channel
	jr nz,l1
	ld e,l				;reload if overflow
	sub l				;and set carry if note is not zero (mute)
slide .EQU $
	nop				;slide for drum
l1
	dec d				;counter of second channel
	jr nz,l2
	ld d,h				;reload if overflow
	sub h				;and set carry if note is not zero (mute)
l2
	sbc a,a				;if carry, A=255, otherwise A=0
#ifdef TI82
	xor %11111100			;+ a=$ff -> a=$c0, a=0 -> a=$fc
	and %00111100
	add a,$c0
#else	
	jr nz,$+4		;7/12
	or $fc			;7
	jr $+3			;12  26
	nop				;4
#endif
	out (0),a		;11  27
	out (0),a
	out (0),a
	out (0),a			;+ 4x to compensate higher cpu speed

	xor a			;+ new keyhandler
	out (1),a
	in a,(1)			;read keyboard
	cpl
	bit 6,a
	jr nz,l3			;if any key is pressed, exit loop
	
	dec bc
	ld a,b
	or c
	jr nz,soundLoop			;113/123t + not anymore

l3
	exx
	
	jr nz,$+4			;if any key was pressed, break loop
	djnz readRow

	pop de
	pop hl
	jr z,readPos			;if no key was pressed, continue

	ret


musicData
#include "ti1bit/huby/music.asm"

#ifdef TI83
.END
	dw $0000
.END
#endif