;#define TI82				; select target platform here
#define TI82CS
;#define TI83

#define LOOPING				; comment out if you don't want your song to loop

#ifdef TI82
#include CRASH82.INC
#endif

#ifdef TI82CS
#include CRASH196.INC
#endif

#ifdef TI83
#nolist
#include ion.inc
#list
	.ORG	progstart
	xor a
	jr	nc,START
	ret
#endif

.DB "WHAM MUSIC BOX TI 1.0", 0		; put a song name of your choice here
#define DEFB .byte
#define DEFW .word

;2-channel beeper engine by Mark Alexander 1985
;Reverse-engineered and enhanced by Chris Cowley 2011
;Modified for TI82/CrASH and TI83/Ion by utz 2012

START
.MODULE WHAM

			LD   HL,MUSICDATA			;  <- Pointer to Music Data. Change
								;     this to play a different song
			LD   A,(HL)				; Get the loop start pointer
			LD   (_PATTERN_LOOP_BEGIN),A
			INC  HL
			LD   A,(HL)				; Get the song end pointer
			LD   (_PATTERN_LOOP_END),A
			INC  HL
			LD   (_PATTERNDATA1),HL
			LD   (_PATTERNDATA2),HL
			LD   A,254
			LD   (_PATTERN_PTR),A			; Set the pattern pointer to zero
			DI
			CALL  _NEXT_PATTERN


_NEXTNOTE		CALL  _PLAYNOTE
			xor a				;+ new keyhandler
			out (1),a
			in a,(1)				;read keyboard
			cpl
			bit 6,a

			JR    Z,_NEXTNOTE			; Play next note if no key pressed

			EI
#ifndef TI83
			ld a,%00010110				;+ set interrupts back to normal
			out (4),a
#endif
			RET					; Uncomment when CALLing from own programs
			;JP EXIT_2_TIOS				; Comment out when CALLing from own programs

_PATTERN_PTR		DEFB 0
_NOTE_PTR		DEFB 0


; ********************************************************************************************************
; * NEXT_PATTERN
; *
; * Select the next pattern in sequence (and handle looping if we've reached PATTERN_LOOP_END
; * Execution falls through to PLAYNOTE to play the first note from our next pattern
; ********************************************************************************************************

_NEXT_PATTERN		LD   A,(_PATTERN_PTR)
			INC  A
			INC  A
			DEFB $FE				; CP n
_PATTERN_LOOP_END	DEFB 0
			JR   NZ,_NO_PATTERN_LOOP
			DEFB $3E				; LD A,n
_PATTERN_LOOP_BEGIN	DEFB 0
#ifndef LOOPING
			POP  HL				;uncomment this if you don't want to loop
			EI					;uncomment this if you don't want to loop
			RET					;uncomment this if you don't want to loop
#endif
_NO_PATTERN_LOOP	LD   (_PATTERN_PTR),A
			DEFB $21				; LD HL,nn
_PATTERNDATA1		DEFW $0000
			LD   E,A				; (this is the first byte of the pattern)
			LD   D,0				; and store it at TEMPO
			ADD  HL,DE
			LD   E,(HL)
			INC  HL
			LD   D,(HL)
			LD   A,(DE)				; Pattern Tempo -> A
			LD   (TEMPO),A				; Store it at TEMPO

			LD   A,1
			LD   (_NOTE_PTR),A

_PLAYNOTE		DEFB $21				; LD HL,nn

_PATTERNDATA2		DEFW $0000
			LD   A,(_PATTERN_PTR)
			LD   E,A
			LD   D,0
			ADD  HL,DE
			LD   E,(HL)
			INC  HL
			LD   D,(HL)				; Now DE = Start of Pattern data
			LD   A,(_NOTE_PTR)
			LD   L,A
			LD   H,0
			ADD  HL,DE				; Now HL = address of note data
			LD   D,(HL)
			LD   E,1

; IF D = $0 then we are at the end of the pattern so increment PATTERN_PTR by 2 and set NOTE_PTR=0
			LD   A,D
			AND  A					; Optimised CP 0
			JR   Z,_NEXT_PATTERN

			PUSH DE
			INC  HL
			LD   D,(HL)
			LD   E,1

			LD   A,(_NOTE_PTR)
			INC  A
			INC  A
			LD   (_NOTE_PTR),A			; Increment the note pointer by 2 (one note per chan)
			POP  HL					; Now CH1 freq is in HL, and CH2 freq is in DE

			LD   A,H
			DEC  A
			JR   NZ,_OUTPUT_NOTE

			LD   A,D				; executed only if Channel 2 contains a rest
			DEC  A					; if DE (CH1 note) is also a rest then..
			JR   Z,_PLAY_SILENCE			; Play silence

_OUTPUT_NOTE		LD   A,(TEMPO)
			LD   C,A
			LD   B,0
			LD   A,0				; ex LD A,BORDER_COL
			EX   AF,AF'
			LD   A,0				; So now BC = TEMPO, A and A' = BORDER_COL
			LD   IXH,D
#ifndef TI83
			LD   D,$3C				;+ easier value for port write
#else
			LD   D,$03
#endif
_lEAE5			NOP
			NOP
_lEAE7			EX   AF,AF'
			DEC  E
			push af
			xor %11111100				;+ a=$c3 -> a=$c0, a=0 -> a=$fc
			out (0),a
			nop
			pop af
			JR   NZ,_lEB04

			LD   E,IXH
			XOR  D
			EX   AF,AF'
			DEC  L
			JP   NZ,_lEB0B

_lEAF5			push af					;11
			xor %11111100				;7
			out (0),a				;(11)
			nop					;4
			pop af					;10 -> +32t
			LD   L,H
			XOR  D
			DJNZ _lEAE5

			INC  C
			JP   NZ,_lEAE7

			RET

_lEB04			JR   Z,_lEB04
			EX   AF,AF'
			DEC  L
			JP   Z,_lEAF5

_lEB0B			push af
			xor %11111100
			out (0),a
			nop
			pop af

			NOP
			NOP
			DJNZ _lEAE5
			INC  C
			JP   NZ,_lEAE7
			RET

_PLAY_SILENCE		LD   A,(TEMPO)
			CPL
			LD   C,A
			PUSH BC
			PUSH AF
			LD   B,0
_SILENCE_LOOP		PUSH HL					;11
			LD   HL,0000				;10
			SRA  (HL)				;15
			SRA  (HL)				;15
			SRA  (HL)				;15
			NOP					;4
			ld hl,0000
			ld hl,0000
			nop
			nop
			nop					;+32t speed adjustment
			POP  HL					;10
			DJNZ _SILENCE_LOOP			;13/8
			DEC  C
			JP   NZ,_SILENCE_LOOP
			POP  AF
			POP  BC
			RET


; *** DATA ***
.INCLUDE "ti1bit/mbox/music.asm"

#ifdef TI83
.END
	DEFW $0000
.END
#endif
